// generated by pgo2go legalsflips.pgo; DO NOT EDIT

package libothello

// amount to shift a board by to move the pieces in that direction
const (
	// left shift amounts
	ulShift = 9
	urShift = 7
	lShift  = 1
	// right shift amounts
	rShift  = 1
	dlShift = 7
	drShift = 9
)

// AND these with the board to cut off the edges
const (
	lMask = 0x7f7f7f7f7f7f7f7f
	rMask = 0xfefefefefefefefe
)

// Legals gives a map of legal moves for the given current
// Thanks Todd and Carl for the algorithm
func (g *Game) Legals() Bitmap {
	current := g.Board.Current
	opponent := g.Board.Opponent

	var legals, temp Bitmap

	temp = current & lMask << ulShift & opponent
	temp |= temp & lMask & opponent << ulShift
	temp |= temp & lMask & opponent << ulShift
	temp |= temp & lMask & opponent << ulShift
	temp |= temp & lMask & opponent << ulShift
	temp |= temp & lMask & opponent << ulShift
	temp |= temp & lMask & opponent << ulShift
	legals |= temp
	temp = current & lMask << lShift & opponent
	temp |= temp & lMask & opponent << lShift
	temp |= temp & lMask & opponent << lShift
	temp |= temp & lMask & opponent << lShift
	temp |= temp & lMask & opponent << lShift
	temp |= temp & lMask & opponent << lShift
	temp |= temp & lMask & opponent << lShift
	legals |= temp
	temp = current & rMask << urShift & opponent
	temp |= temp & rMask & opponent << urShift
	temp |= temp & rMask & opponent << urShift
	temp |= temp & rMask & opponent << urShift
	temp |= temp & rMask & opponent << urShift
	temp |= temp & rMask & opponent << urShift
	temp |= temp & rMask & opponent << urShift
	legals |= temp
	temp = current & lMask >> dlShift & opponent
	temp |= temp & lMask & opponent >> dlShift
	temp |= temp & lMask & opponent >> dlShift
	temp |= temp & lMask & opponent >> dlShift
	temp |= temp & lMask & opponent >> dlShift
	temp |= temp & lMask & opponent >> dlShift
	temp |= temp & lMask & opponent >> dlShift
	legals |= temp
	temp = current & rMask >> rShift & opponent
	temp |= temp & rMask & opponent >> rShift
	temp |= temp & rMask & opponent >> rShift
	temp |= temp & rMask & opponent >> rShift
	temp |= temp & rMask & opponent >> rShift
	temp |= temp & rMask & opponent >> rShift
	temp |= temp & rMask & opponent >> rShift
	legals |= temp
	temp = current & rMask >> drShift & opponent
	temp |= temp & rMask & opponent >> drShift
	temp |= temp & rMask & opponent >> drShift
	temp |= temp & rMask & opponent >> drShift
	temp |= temp & rMask & opponent >> drShift
	temp |= temp & rMask & opponent >> drShift
	temp |= temp & rMask & opponent >> drShift
	legals |= temp
	temp = current << 8 & opponent
	temp |= temp & opponent << 8
	temp |= temp & opponent << 8
	temp |= temp & opponent << 8
	temp |= temp & opponent << 8
	temp |= temp & opponent << 8
	temp |= temp & opponent << 8
	legals |= temp
	temp = current >> 8 & opponent
	temp |= temp & opponent >> 8
	temp |= temp & opponent >> 8
	temp |= temp & opponent >> 8
	temp |= temp & opponent >> 8
	temp |= temp & opponent >> 8
	temp |= temp & opponent >> 8
	legals |= temp

	return legals & g.Board.EmptyMap()
}

// LegalMoves is a convenience function for getting a list of the legal moves
// and their count.
func (g *Game) LegalMoves() ([]Move, int) {
	return g.Legals().MSplit()
}

// Flips gives a map of the pieces flipped by a move.
func (g *Game) Flips(m Move) Bitmap {
	var result, temp Bitmap

	current := g.Board.Current
	opponent := g.Board.Opponent

	mBmp := Bitmap(m)

	temp = mBmp & lMask << ulShift & opponent
	temp |= temp & lMask & opponent << ulShift
	temp |= temp & lMask & opponent << ulShift
	temp |= temp & lMask & opponent << ulShift
	temp |= temp & lMask & opponent << ulShift
	temp |= temp & lMask & opponent << ulShift
	temp |= temp & lMask & opponent << ulShift
	if temp&current != 0 {
		result |= temp
	}
	temp = mBmp & lMask << lShift & opponent
	temp |= temp & lMask & opponent << lShift
	temp |= temp & lMask & opponent << lShift
	temp |= temp & lMask & opponent << lShift
	temp |= temp & lMask & opponent << lShift
	temp |= temp & lMask & opponent << lShift
	temp |= temp & lMask & opponent << lShift
	if temp&current != 0 {
		result |= temp
	}
	temp = mBmp & rMask << urShift & opponent
	temp |= temp & rMask & opponent << urShift
	temp |= temp & rMask & opponent << urShift
	temp |= temp & rMask & opponent << urShift
	temp |= temp & rMask & opponent << urShift
	temp |= temp & rMask & opponent << urShift
	temp |= temp & rMask & opponent << urShift
	if temp&current != 0 {
		result |= temp
	}

	temp = mBmp & lMask >> dlShift & opponent
	temp |= temp & lMask & opponent >> dlShift
	temp |= temp & lMask & opponent >> dlShift
	temp |= temp & lMask & opponent >> dlShift
	temp |= temp & lMask & opponent >> dlShift
	temp |= temp & lMask & opponent >> dlShift
	temp |= temp & lMask & opponent >> dlShift
	if temp&current != 0 {
		result |= temp
	}
	temp = mBmp & rMask >> rShift & opponent
	temp |= temp & rMask & opponent >> rShift
	temp |= temp & rMask & opponent >> rShift
	temp |= temp & rMask & opponent >> rShift
	temp |= temp & rMask & opponent >> rShift
	temp |= temp & rMask & opponent >> rShift
	temp |= temp & rMask & opponent >> rShift
	if temp&current != 0 {
		result |= temp
	}
	temp = mBmp & rMask >> drShift & opponent
	temp |= temp & rMask & opponent >> drShift
	temp |= temp & rMask & opponent >> drShift
	temp |= temp & rMask & opponent >> drShift
	temp |= temp & rMask & opponent >> drShift
	temp |= temp & rMask & opponent >> drShift
	temp |= temp & rMask & opponent >> drShift
	if temp&current != 0 {
		result |= temp
	}

	temp = mBmp << 8 & opponent
	temp |= temp & opponent << 8
	temp |= temp & opponent << 8
	temp |= temp & opponent << 8
	temp |= temp & opponent << 8
	temp |= temp & opponent << 8
	temp |= temp & opponent << 8
	if temp&current != 0 {
		result |= temp
	}
	temp = mBmp >> 8 & opponent
	temp |= temp & opponent >> 8
	temp |= temp & opponent >> 8
	temp |= temp & opponent >> 8
	temp |= temp & opponent >> 8
	temp |= temp & opponent >> 8
	temp |= temp & opponent >> 8
	if temp&current != 0 {
		result |= temp
	}

	return result & opponent
}

// vim:ft=go:sts=8:sw=8:noet
